<?php

/**
 *
 * PHP Pro Bid $Id$ zq46/K+KjKEqjYNKkDtRbuxsYebOO/osTqlIUPLDDPQ=
 *
 * @link        http://www.phpprobid.com
 * @copyright   Copyright (c) 2014 Only For Testing BBC No Leech & CodeCube SRL
 * @license     http://www.phpprobid.com/license Commercial License
 *
 * @version     7.0
 */
/**
 * output a set of selected custom field elements
 */

namespace Ppb\Form\Element;

use Cube\Form\Element,
    Cube\Controller\Front;

class CustomFields extends Element
{

    /**
     *
     * type of element - override the variable from the parent class
     *
     * @var string
     */
    protected $_element = 'CustomFields';

    /**
     *
     * class constructor
     *
     * @param string $name
     * @param array  $data custom field data
     */
    public function __construct($name, array $data)
    {
        parent::__construct($this->_element, $name);

        $this->_baseUrl = Front::getInstance()->getRequest()->getBaseUrl();

        if (isset($data['subtitle'])) {
            $this->setSubtitle($data['subtitle']);
        }

        if (isset($data['label'])) {
            $this->setLabel($data['label']);
        }

        if (isset($data['prefix'])) {
            $this->setPrefix($data['prefix']);
        }

        if (isset($data['suffix'])) {
            $this->setSuffix($data['suffix']);
        }

        if (isset($data['attributes'])) {
            $this->setAttributes($data['attributes']);
        }

        if (isset($data['value'])) {
            $this->setValue($data['value']);
        }

        if (isset($data['description'])) {
            $this->setDescription($data['description']);
        }

        if (isset($data['required'])) {
            $this->setRequired($data['required']);
        }

        if (isset($data['multiple'])) {
            $this->setMultiple($data['multiple']);
        }

        if (isset($data['multiOptions'])) {
            $this->setMultiOptions($data['multiOptions']);
        }

        if (isset($data['validators'])) {
            $this->setValidators($data['validators']);
        }

        if (isset($data['headerCode'])) {
            $this->setHeaderCode($data['headerCode']);
        }

        if (isset($data['bodyCode'])) {
            $this->setBodyCode($data['bodyCode']);
        }

        if (isset($data['customData'])) {
            $this->setCustomData($data['customData']);
        }
    }

}

